<?php
/***************************************************************************
 *                               notes.php
 *                            -------------------
 *   copyright            : (C) 2003 OXPUS
 *   email                : administrator@oxpus.de
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

define('IN_PHPBB', true);
$phpbb_root_path = './';
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);
include($phpbb_root_path . 'includes/functions_post.'.$phpEx);
include($phpbb_root_path . 'includes/functions_search.'.$phpEx);
include($phpbb_root_path . 'includes/bbcode.'.$phpEx);

//
// Start session management
//
$userdata = session_pagestart($user_ip, PAGE_PROFILE);
init_userprefs($userdata);
//
// End session management
//

// Check user logged in
if ( !$userdata['session_logged_in'] )
{
	redirect(append_sid("login.$phpEx", true) . '');
}

// Getting submit status
$submit = $HTTP_POST_VARS['submit'];

// Getting sorting values
$sql_order = ( $HTTP_POST_VARS['sort_order'] == 'DESC' ) ? 'DESC' : 'ASC';
$sql_order_by = ( $HTTP_POST_VARS['sort_by'] == 'post_subject' ) ? 'post_subject' : 'post_time';

// Set sorting
$sort_order = '<select name="sort_order">';
$sort_order .= '<option value="ASC">'.$lang['Sort_Ascending'].'</option>';
$sort_order .= '<option value="DESC">'.$lang['Sort_Descending'].'</option>';
$sort_order .= '</select>';

$sort_order = str_replace('value="'.$sql_order.'">', 'value="'.$sql_order.'" SELECTED>', $sort_order);

$sort_by = '<select name="sort_by">';
$sort_by .= '<option value="post_subject">'.$lang['Subject'].'</option>';
$sort_by .= '<option value="post_time">'.$lang['Time'].'</option>';
$sort_by .= '</select>';

$sort_by = str_replace('value="'.$sql_order_by.'">', 'value="'.$sql_order_by.'" SELECTED>', $sort_by);

// Getting search string
$search_keywords = $HTTP_POST_VARS['search_string'];
$sql_search_in = $HTTP_POST_VARS['search_in'];
$search_in = '<select name="search_in">';
$search_in .= '<option value="post_subject">'.$lang['Subject'].'</option>';
$search_in .= '<option value="post_text">'.$lang['Post'].'</option>';
$search_in .= '</select>';

$search_in = str_replace('value="'.$sql_search_in.'">', 'value="'.$sql_search_in.'" SELECTED>', $search_in);

$sql_search = '';

// Prepare search
if ( $search_keywords != '' )
{
	// Look for stopwords and synonyms
	$stopword_array = @file($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/search_stopwords.txt');
	$synonym_array = @file($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/search_synonyms.txt');

	// Prepare search terms
	$split_search = array();
	$sql_search_terms = '';
	$split_search = ( !strstr($multibyte_charset, $lang['ENCODING']) ) ?  split_words(clean_words('search', stripslashes($search_keywords), $stopword_array, $synonym_array), 'search') : split(' ', $search_keywords);

	foreach($split_search as $search_word)
	{
		$sql_search_terms .= ( $sql_search_terms != '' ) ? ' OR ' . $sql_search_in . ' LIKE (\'%'.$search_word . '%\')' : $sql_search_in . ' LIKE (\'%' . $search_word . '%\')';
	}

	$sql_search = ' AND (' . $sql_search_terms . ')';
}

//
// Go ahead and pull all data for the notes
//
$postrow = array();
$i = 0;

$sql = "SELECT * FROM " . NOTES_TABLE . "
	WHERE poster_id = " . $userdata['user_id'] . "
	$sql_search
	ORDER BY $sql_order_by $sql_order";
if ( !($result = $db->sql_query($sql)) )
{
	message_die(GENERAL_ERROR, "Could not obtain notes/user information.", '', __LINE__, __FILE__, $sql);
}

while ($row = $db->sql_fetchrow($result))
{
	$i++;
	$postrow[] = $row;
}

$total_notes = $i;

//
// Load templates
//
$template->set_filenames(array(
	'body' => 'notes_body.tpl')
);

//
// Output page header
//
if ( $userdata['user_popup_notes'] == TRUE )
{
	$gen_simple_header = TRUE;
	$template->assign_block_vars('switch_popup', array());
}
else
{
	$template->assign_block_vars('switch_no_popup', array());
}

$page_title = $lang['Notes'] . ' - ' . $userdata['username'];
include($phpbb_root_path . 'includes/page_header.'.$phpEx);

if ( $total_notes < $board_config['notes'] )
{
	$template->assign_block_vars('new_note', array(
		'POST_IMG' => $images['post_new'],
		'U_POST_NEW_TOPIC' => append_sid("posting_notes.$phpEx?mode=newtopic"))
	);
}

$highlight = 'FFFF00';

//
// Send vars to template
//
$template->assign_vars(array(
	'L_NOTES' => $lang['Notes'] . ' ( '. $total_notes . ' / ' . $board_config['notes'] . ' )',
	'L_POSTED' => $lang['Posted'],
	'L_POST_SUBJECT' => $lang['Post_subject'],
	'L_BACK_TO_TOP' => $lang['Back_to_top'],
	'L_DELETE_TOPIC' => $lang['Delete_topic'],
	'L_CLOSE' => $lang['Close_window'],
	'L_SEARCH' => ( $search_keywords == '' ) ? $lang['Search'] : $lang['Search'].'*',
	'L_FILTER' => ( $search_keywords != '' ) ? $lang['Filter_notes'] : '',
	'L_SORT' => $lang['Sort'],
	'SORT_ORDER' => $sort_order,
	'SORT_BY' => $sort_by,
	'SEARCH_IN' => $search_in,
	'S_ACTION' => append_sid("notes.$phpEx"))
);

//
// Okay, let's do the loop, yeah come on baby let's do the loop
// and it goes like this ...
//
for($i = 0; $i < $total_notes; $i++)
{
	$post_date = create_date($board_config['default_dateformat'], $postrow[$i]['post_time'], $board_config['board_timezone']);
	$subject = stripslashes($postrow[$i]['post_subject']);
	$message = stripslashes($postrow[$i]['post_text']);

	if ( $search_keywords != '' )
	{
		foreach($split_search as $search_word)
		{
			$message = str_replace('\"', '"', substr(preg_replace('#(\>(((?>([^><]+|(?R)))*)\<))#se', "preg_replace('#\b(" . $search_word . ")\b#i', '<span style=\"background:#FFFF00\"><b>\\\\1</b></span>', '\\0')", '>' . $message . '<'), 1, -1));
		}
	}

	$bbcode_on = $postrow[$i]['bbcode'];
	$uid = $row['bbcode_uid'];
	$smilies_on = $postrow[$i]['smilies'];
	$acronym_on = $postrow[$i]['acronym'];
	$uid = $postrow[$i]['bbcode_uid'];
	$message = ( $bbcode_on == 1 ) ? bbencode_second_pass($message, $uid) : preg_replace('/\:(([a-z0-9]:)?)' . $uid . '/s', '', $message);
	$message = make_clickable($message);
	if ( $board_config['allow_smilies'] && $smilies_on == 1 )
	{
		$message = smilies_pass($message);
	}
	if ( $acronym_on == 1 )
	{
		$sql = "SELECT acronym FROM " . ACRONYMS_TABLE . " LIMIT 0,1";
		if($result = @$db->sql_query($sql))
		{
			$message = acronym_pass($message);
		}
	}
	$message = str_replace("\n", "\n<br />\n", $message);
	$temp_url = append_sid("posting_notes.$phpEx?mode=editpost&amp;" . POST_POST_URL . "=" . $postrow[$i]['post_id']);
	$edit_img = '<a href="' . $temp_url . '"><img src="' . $images['icon_edit'] . '" alt="' . $lang['Edit_delete_post'] . '" title="' . $lang['Edit_delete_post'] . '" border="0" style="filter:alpha(opacity=65)" onMouseOver="this.filters.alpha.opacity=100" onMouseOut="this.filters.alpha.opacity=65" /></a>';
	$edit = '<a href="' . $temp_url . '">' . $lang['Edit_delete_post'] . '</a>';
	$temp_url = append_sid("posting_notes.$phpEx?mode=delete&amp;" . POST_POST_URL . "=" . $postrow[$i]['post_id']);
	$delpost_img = '<a href="' . $temp_url . '"><img src="' . $images['icon_delpost'] . '" alt="' . $lang['Delete_post'] . '" title="' . $lang['Delete_post'] . '" border="0" style="filter:alpha(opacity=65)" onMouseOver="this.filters.alpha.opacity=100" onMouseOut="this.filters.alpha.opacity=65" /></a>';
	$delpost = '<a href="' . $temp_url . '">' . $lang['Delete_post'] . '</a>';

	//
	// Again this will be handled by the templating
	// code at some point
	//
	$row_color = ( !($i % 2) ) ? $theme['td_class2'] : $theme['td_class1'];
	$row_class = ( !($i % 2) ) ? $theme['td_class1'] : $theme['td_class2'];

	$template->assign_block_vars('postrow', array(
		'ROW_COLOR' => $row_color,
		'ROW_CLASS' => $row_class,
		'POST_DATE' => $post_date,
		'POST_SUBJECT' => trim(stripslashes($subject)),
		'MESSAGE' => trim(stripslashes($message)),
		'DELETE_IMG' => $delpost_img,
		'DELETE' => $delpost,
		'EDIT_IMG' => $edit_img,
		'EDIT' => $edit)
	);
}

$template->pparse('body');

include($phpbb_root_path . 'includes/page_tail.'.$phpEx);

?>
