<?php

define('IN_PHPBB', true);
$phpbb_root_path = './';
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);
include($phpbb_root_path . 'includes/functions_post.'.$phpEx);
include($phpbb_root_path . 'includes/bbcode.'.$phpEx);

//
// Start session management
//
$userdata = session_pagestart($user_ip, PAGE_POSTING);
init_userprefs($userdata);
//
// End session management
//

//
// Check and set various parameters
//
$params = array('submit' => 'post', 'cancel' => 'cancel', 'mode' => 'mode', 'post_id' => POST_POST_URL);
while( list($var, $param) = @each($params) )
{
	if ( !empty($HTTP_POST_VARS[$param]) || !empty($HTTP_GET_VARS[$param]) )
	{
		$$var = ( !empty($HTTP_POST_VARS[$param]) ) ? $HTTP_POST_VARS[$param] : $HTTP_GET_VARS[$param];
	}
	else
	{
		$$var = '';
	}
}

$post_id = intval($post_id);

if ( $mode == 'smilies' )
{
	generate_smilies('window', PAGE_POSTING);
	exit;
}
else if ( $mode == 'charmap' )
{
	charmap(PAGE_POSTING);
	exit;
}

// Check for existing session
if ( !$userdata['session_logged_in'] )
{
	redirect(append_sid("login.$phpEx", true) . '');
}

// --------------------
//  What shall we do?
//

if ( $mode == 'delete' )
{
	$sql = "DELETE FROM " . NOTES_TABLE . "
			WHERE post_id = ".$post_id."
			AND poster_id = " . $userdata['user_id'] . " ";
	if (!$db->sql_query($sql))
	{
		message_die(GENERAL_ERROR, 'Error in deleting post', '', __LINE__, __FILE__, $sql);
	}
	redirect(append_sid("notes.$phpEx", true) . '');
}

if ( $cancel )
{
	redirect(append_sid("notes.$phpEx", true) . '');
}

if ( $submit )
{
	$subject = $HTTP_POST_VARS['subject'];
	$message = $HTTP_POST_VARS['message'];

	$bbcode_on = $board_config['allow_bbcode'];
	$smilie_on = $board_config['allow_smilies'];
	if (!empty($message))
	{
		$bbcode_uid = ($board_config['allow_bbcode']) ? make_bbcode_uid() : '';
		$message = prepare_message(trim($message), 1, $bbcode_on, $smilie_on, $bbcode_uid);
	}

	$bbcode_on = ( intval($HTTP_POST_VARS['bbcode']) == 1 ) ? 0 : 1;
	$smilies_on = ( intval($HTTP_POST_VARS['smilies']) == 1 ) ? 0 : 1;
	$acronym_on = ( intval($HTTP_POST_VARS['acronym']) == 1 ) ? 0 : 1;

	$subject = str_replace("\'", "''", $subject);
	$message = str_replace("\'", "''", $message);

	if ( $mode == 'newtopic' )
	{
		$current_time = time();
		$sql = "INSERT INTO " . NOTES_TABLE . "
			(post_subject, poster_id, post_time, post_text, bbcode_uid, bbcode, smilies, acronym) VALUES ('$subject', " . $userdata['user_id'] . ", $current_time, '$message', '$bbcode_uid', $bbcode_on, $smilies_on, $acronym_on)";
			if (!$db->sql_query($sql))
			{
				message_die(GENERAL_ERROR, 'Error in posting', '', __LINE__, __FILE__, $sql);
			}
		redirect(append_sid("notes.$phpEx", true) . '');
	}
	else if ( $mode == 'editpost' )
	{
		$sql = "UPDATE " . NOTES_TABLE . "
			SET post_subject = '$subject', post_text = '$message', bbcode_uid = '$bbcode_uid', bbcode = $bbcode_on, smilies = $smilies_on, acronym = $acronym_on
			WHERE post_id = $post_id";
			if (!$db->sql_query($sql))
			{
				message_die(GENERAL_ERROR, 'Error in posting', '', __LINE__, __FILE__, $sql);
			}
		redirect(append_sid("notes.$phpEx", true) . '');
	}
}

// User default entry point
//
if ( $mode == 'newtopic' )
{
	$subject = '';
	$message = '';
	$page_title = $lang['Post_a_new_topic'];
	$bbcode_on = 1;
	$smilies_on = 1;
	$acronym_on = 1;
}

$uid = '';

if ( $mode == 'editpost' )
{
	$sql = "SELECT * FROM " . NOTES_TABLE . "
			WHERE post_id = ".$post_id."
			AND poster_id = " . $userdata['user_id'] . " ";
		if (!$result = $db->sql_query($sql))
		{
			message_die(GENERAL_ERROR, "Couldn't query notes table", '', __LINE__, __FILE__, $sql);
		}
		else
		{
			while( $row = $db->sql_fetchrow($result) )
			{
				$subject = $row['post_subject'];
				$bbcode_on = $row['bbcode'];
				$smilies_on = $row['smilies'];
				$acronym_on = $row['acronym'];
				$uid = $row['bbcode_uid'];
				$message = $row['post_text'];
				if ( $row['bbcode_uid'] != '' )
				{
					$message = preg_replace('/\:(([a-z0-9]:)?)' . $uid . '/s', '', $message);
				}
			}
		}
	$page_title = $lang['Edit_Post'];
}

//
// Include page header
//
if ( $userdata['user_popup_notes'] == TRUE )
{
	$gen_simple_header = TRUE;
	$template->assign_block_vars('switch_popup', array());
}
else
{
	$template->assign_block_vars('switch_no_popup', array());
}
include_once($phpbb_root_path . 'includes/bbc_box_tags.'.$phpEx); 
include($phpbb_root_path . 'includes/page_header.'.$phpEx);

$template->set_filenames(array(
	'body' => 'posting_notes_body.tpl')
);

$template->assign_vars(array(
	'L_POST_A' => $page_title,
	'L_POST_SUBJECT' => $lang['Post_subject'])
);

if ( $board_config['allow_smilies'] )
{
	$smilies_status = $lang['Smilies_are_ON'];
	$u_smilies = append_sid("posting_notes.$phpEx?mode=smilies");
	$l_smilies = $lang['Emoticons'];
	$template->assign_block_vars('switch_smilies_on', array());
}
else
{
	$smilies_status = $lang['Smilies_are_OFF'];
	$u_smilies = '';
	$l_smilies = '';
}

if ( $board_config['allow_bbcode'] )
{
	$smilies_status .= '<br />'.sprintf($lang['BBCode_is_ON'], '', '');
	$template->assign_block_vars('switch_bbcode_on', array());
}
else
{
	$smilies_status .= '<br />'.sprintf($lang['BBCode_is_OFF'], '', '');
}

$sql = "SELECT acronym FROM " . ACRONYMS_TABLE . " LIMIT 0,1";
if($result = @$db->sql_query($sql))
{
	$l_message_body = $lang['Message_body'].'<br /><br /></b>'.$smilies_status.'<br />'.$lang['Acronym_on'].'</span>';
	$template->assign_block_vars('switch_acronym_on', array());
}
else
{
	$l_message_body = $lang['Message_body'].'<br /><br /></b>'.$smilies_status;
}

//
// Output the data to the template
//

$template->assign_vars(array(
	'SUBJECT' => $subject,
	'MESSAGE' => $message,
	'BBCODE_ON' => ( $bbcode_on == 0 ) ? 'checked="checked"' : '',
	'SMILIES_ON' => ( $smilies_on == 0 )  ? 'checked="checked"' : '',
	'ACRONYM_ON' => ( $acronym_on == 0 )  ? 'checked="checked"' : '',
	'L_FONT_COLOR' => $lang['Font_color'],
	'L_FONT_SIZE' => $lang['Font_size'],
	'L_SUBJECT' => $lang['Subject'],
	'L_MESSAGE_BODY' => $l_message_body,
	'L_SUBMIT' => $lang['Submit'],
	'L_OPTIONS' => $lang['Options'],
	'L_BBCODE_ON' => $lang['Disable_BBCode_post'],
	'L_SMILIES_ON' => $lang['Disable_Smilies_post'],
	'L_ACRONYM_ON' => $lang['Disable_Acronym_post'],
	'L_CANCEL' => $lang['Cancel'],
	'L_CONFIRM_DELETE' => $lang['Confirm_delete'],
	'L_DELETE_POST' => $lang['Delete_post'],
	'S_POST_ACTION' => append_sid("posting_notes.$phpEx?mode=".$mode.'&amp;'.POST_POST_URL.'='.$post_id),
	'L_SMILIES' => $l_smilies,
	'U_SMILIES' => $u_smilies,
	'L_CLOSE' => $lang['Close_window'])
);

$template->pparse('body');

include($phpbb_root_path . 'includes/page_tail.'.$phpEx);

?>