#
# Drops
# We wrote in install, that we have to drop some tables
#

DROP TABLE `ina_at_scores`;
DROP TABLE `iNA_AT_SCORES`;
DROP TABLE `orion_admin_nav_module`;
DROP TABLE `orion_anti_robotic_reg`;
DROP TABLE `orion_hacks_list`;
DROP TABLE `orion_ina`;
DROP TABLE `orion_ina_data`;
DROP TABLE `orion_ina_games`;
DROP TABLE `orion_ina_scores`;
DROP TABLE `orion_themes`;
DROP TABLE `orion_themes_name`;
DROP TABLE `orion_xtconf`;
DROP TABLE `orion_links`;
DROP TABLE `orion_cracktrack`;

DROP TABLE `orion_downloads_cat`;
DROP TABLE `orion_downloads`;
DROP TABLE `orion_dl_ratings`;
DROP TABLE `orion_dl_config`;
DROP TABLE `orion_dl_auth`;

DROP TABLE `orion_kb_articles`;
DROP TABLE `orion_kb_categories`;
DROP TABLE `orion_kb_config`;
DROP TABLE `orion_kb_custom`;
DROP TABLE `orion_kb_customdata`;
DROP TABLE `orion_kb_results`;
DROP TABLE `orion_kb_search`;
DROP TABLE `orion_kb_types`;
DROP TABLE `orion_kb_votes`;
DROP TABLE `orion_kb_word`;
DROP TABLE `orion_kb_wordlist`;

#
# Added in Orion 2.0.1 (phpBB 2.0.18)
#

CREATE TABLE `orion_sessions_keys` (
	`key_id` varchar(32) DEFAULT '0' NOT NULL,
	`user_id` mediumint(8) DEFAULT '0' NOT NULL,
	`last_ip` varchar(8) DEFAULT '0' NOT NULL,
	`last_login` int(11) DEFAULT '0' NOT NULL,
	PRIMARY KEY (`key_id`, `user_id`),
	KEY `last_login` (`last_login`));


#
# Table structure for table `orion_acronyms`
#

CREATE TABLE `orion_acronyms` (
  `acronym_id` mediumint(9) NOT NULL auto_increment,
  `acronym` varchar(80) NOT NULL default '',
  `description` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`acronym_id`)
) TYPE=MyISAM AUTO_INCREMENT=2 ;


#
# Table structure for table `orion_album`
#

CREATE TABLE `orion_album` (
  `pic_id` int(11) unsigned NOT NULL auto_increment,
  `pic_filename` varchar(255) NOT NULL default '',
  `pic_thumbnail` varchar(255) default NULL,
  `pic_title` varchar(255) NOT NULL default '',
  `pic_desc` text,
  `pic_user_id` mediumint(8) NOT NULL default '0',
  `pic_username` varchar(32) default NULL,
  `pic_user_ip` varchar(8) NOT NULL default '0',
  `pic_time` int(11) unsigned NOT NULL default '0',
  `pic_cat_id` mediumint(8) unsigned NOT NULL default '1',
  `pic_view_count` int(11) unsigned NOT NULL default '0',
  `pic_lock` tinyint(3) NOT NULL default '0',
  `pic_approval` tinyint(3) NOT NULL default '1',
  PRIMARY KEY  (`pic_id`),
  KEY `pic_cat_id` (`pic_cat_id`),
  KEY `pic_user_id` (`pic_user_id`),
  KEY `pic_time` (`pic_time`)
) TYPE=MyISAM AUTO_INCREMENT=3 ;


#
# Table structure for table `orion_album_cat`
#

CREATE TABLE `orion_album_cat` (
  `cat_id` mediumint(8) unsigned NOT NULL auto_increment,
  `cat_title` varchar(255) NOT NULL default '',
  `cat_desc` text,
  `cat_order` mediumint(8) NOT NULL default '0',
  `cat_view_level` tinyint(3) NOT NULL default '-1',
  `cat_upload_level` tinyint(3) NOT NULL default '0',
  `cat_rate_level` tinyint(3) NOT NULL default '0',
  `cat_comment_level` tinyint(3) NOT NULL default '0',
  `cat_edit_level` tinyint(3) NOT NULL default '0',
  `cat_delete_level` tinyint(3) NOT NULL default '2',
  `cat_view_groups` varchar(255) default NULL,
  `cat_upload_groups` varchar(255) default NULL,
  `cat_rate_groups` varchar(255) default NULL,
  `cat_comment_groups` varchar(255) default NULL,
  `cat_edit_groups` varchar(255) default NULL,
  `cat_delete_groups` varchar(255) default NULL,
  `cat_moderator_groups` varchar(255) default NULL,
  `cat_approval` tinyint(3) NOT NULL default '0',
  PRIMARY KEY  (`cat_id`),
  KEY `cat_order` (`cat_order`)
) TYPE=MyISAM AUTO_INCREMENT=3 ;


#
# Table structure for table `orion_album_comment`
#

CREATE TABLE `orion_album_comment` (
  `comment_id` int(11) unsigned NOT NULL auto_increment,
  `comment_pic_id` int(11) unsigned NOT NULL default '0',
  `comment_user_id` mediumint(8) NOT NULL default '0',
  `comment_username` varchar(32) default NULL,
  `comment_user_ip` varchar(8) NOT NULL default '',
  `comment_time` int(11) unsigned NOT NULL default '0',
  `comment_text` text,
  `comment_edit_time` int(11) unsigned default NULL,
  `comment_edit_count` smallint(5) unsigned NOT NULL default '0',
  `comment_edit_user_id` mediumint(8) default NULL,
  PRIMARY KEY  (`comment_id`),
  KEY `comment_pic_id` (`comment_pic_id`),
  KEY `comment_user_id` (`comment_user_id`),
  KEY `comment_user_ip` (`comment_user_ip`),
  KEY `comment_time` (`comment_time`)
) TYPE=MyISAM AUTO_INCREMENT=2 ;


#
# Table structure for table `orion_album_config`
#

CREATE TABLE `orion_album_config` (
  `config_name` varchar(255) NOT NULL default '',
  `config_value` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`config_name`)
) TYPE=MyISAM;


#
# Table structure for table `orion_album_rate`
#

CREATE TABLE `orion_album_rate` (
  `rate_pic_id` int(11) unsigned NOT NULL default '0',
  `rate_user_id` mediumint(8) NOT NULL default '0',
  `rate_user_ip` char(8) NOT NULL default '',
  `rate_point` tinyint(3) unsigned NOT NULL default '0',
  KEY `rate_pic_id` (`rate_pic_id`),
  KEY `rate_user_id` (`rate_user_id`),
  KEY `rate_user_ip` (`rate_user_ip`),
  KEY `rate_point` (`rate_point`)
) TYPE=MyISAM;


#
# Table structure for table `orion_attach_quota`
#

CREATE TABLE `orion_attach_quota` (
  `user_id` mediumint(8) unsigned NOT NULL default '0',
  `group_id` mediumint(8) unsigned NOT NULL default '0',
  `quota_type` smallint(2) NOT NULL default '0',
  `quota_limit_id` mediumint(8) unsigned NOT NULL default '0',
  KEY `quota_type` (`quota_type`)
) TYPE=MyISAM;


#
# Table structure for table `orion_attachments`
#

CREATE TABLE `orion_attachments` (
  `attach_id` mediumint(8) unsigned NOT NULL default '0',
  `post_id` mediumint(8) unsigned NOT NULL default '0',
  `privmsgs_id` mediumint(8) unsigned NOT NULL default '0',
  `user_id_1` mediumint(8) NOT NULL default '0',
  `user_id_2` mediumint(8) NOT NULL default '0',
  KEY `attach_id_post_id` (`attach_id`,`post_id`),
  KEY `attach_id_privmsgs_id` (`attach_id`,`privmsgs_id`)
) TYPE=MyISAM;


#
# Table structure for table `orion_attachments_config`
#

CREATE TABLE `orion_attachments_config` (
  `config_name` varchar(255) NOT NULL default '',
  `config_value` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`config_name`)
) TYPE=MyISAM;


#
# Table structure for table `orion_attachments_desc`
#

CREATE TABLE `orion_attachments_desc` (
  `attach_id` mediumint(8) unsigned NOT NULL auto_increment,
  `physical_filename` varchar(255) NOT NULL default '',
  `real_filename` varchar(255) NOT NULL default '',
  `download_count` mediumint(8) unsigned NOT NULL default '0',
  `comment` varchar(255) default NULL,
  `extension` varchar(100) default NULL,
  `mimetype` varchar(100) default NULL,
  `filesize` int(20) NOT NULL default '0',
  `filetime` int(11) NOT NULL default '0',
  `thumbnail` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`attach_id`),
  KEY `filetime` (`filetime`),
  KEY `physical_filename` (`physical_filename`(10)),
  KEY `filesize` (`filesize`)
) TYPE=MyISAM AUTO_INCREMENT=5 ;


#
# Table structure for table `orion_auth_access`
#

CREATE TABLE `orion_auth_access` (
  `group_id` mediumint(8) NOT NULL default '0',
  `forum_id` smallint(5) unsigned NOT NULL default '0',
  `auth_view` tinyint(1) NOT NULL default '0',
  `auth_read` tinyint(1) NOT NULL default '0',
  `auth_post` tinyint(1) NOT NULL default '0',
  `auth_reply` tinyint(1) NOT NULL default '0',
  `auth_edit` tinyint(1) NOT NULL default '0',
  `auth_delete` tinyint(1) NOT NULL default '0',
  `auth_sticky` tinyint(1) NOT NULL default '0',
  `auth_announce` tinyint(1) NOT NULL default '0',
  `auth_globalannounce` tinyint(1) NOT NULL default '0',
  `auth_vote` tinyint(1) NOT NULL default '0',
  `auth_pollcreate` tinyint(1) NOT NULL default '0',
  `auth_attachments` tinyint(1) NOT NULL default '0',
  `auth_mod` tinyint(1) NOT NULL default '0',
  `auth_news` tinyint(1) NOT NULL default '0',
  `auth_download` tinyint(1) NOT NULL default '0',
  KEY `group_id` (`group_id`),
  KEY `forum_id` (`forum_id`)
) TYPE=MyISAM;


#
# Table structure for table `orion_banlist`
#

CREATE TABLE `orion_banlist` (
  `ban_id` mediumint(8) unsigned NOT NULL auto_increment,
  `ban_userid` mediumint(8) NOT NULL default '0',
  `ban_ip` varchar(8) NOT NULL default '',
  `ban_email` varchar(255) default NULL,
  PRIMARY KEY  (`ban_id`),
  KEY `ban_ip_user_id` (`ban_ip`,`ban_userid`)
) TYPE=MyISAM AUTO_INCREMENT=2 ;


#
# Table structure for table `orion_bbc_box`
#

CREATE TABLE `orion_bbc_box` (
  `bbc_id` smallint(5) unsigned NOT NULL auto_increment,
  `bbc_name` varchar(255) NOT NULL default '',
  `bbc_value` varchar(255) NOT NULL default '',
  `bbc_auth` varchar(255) NOT NULL default '',
  `bbc_before` varchar(255) NOT NULL default '',
  `bbc_after` varchar(255) NOT NULL default '',
  `bbc_helpline` varchar(255) NOT NULL default '',
  `bbc_img` varchar(255) NOT NULL default '',
  `bbc_divider` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`bbc_id`)
) TYPE=MyISAM AUTO_INCREMENT=24 ;


#
# Table structure for table `orion_cal_config`
#

CREATE TABLE `orion_cal_config` (
  `config_name` varchar(255) NOT NULL default '',
  `config_value` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`config_name`)
) TYPE=MyISAM;


#
# Table structure for table `orion_calendar`
#

CREATE TABLE `orion_calendar` (
  `id` int(11) NOT NULL auto_increment,
  `username` varchar(255) default NULL,
  `stamp` datetime default NULL,
  `subject` varchar(255) default NULL,
  `description` blob,
  `user_id` mediumint(1) NOT NULL default '-1',
  `valid` char(3) NOT NULL default 'no',
  `eventspan` date default NULL,
  `bbcode_uid` varchar(10) default NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM AUTO_INCREMENT=5 ;


#
# Table structure for table `orion_chatbox`
#

CREATE TABLE `orion_chatbox` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(99) NOT NULL default '',
  `msg` varchar(255) NOT NULL default '',
  `timestamp` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM AUTO_INCREMENT=130 ;


#
# Table structure for table `orion_chatbox_session`
#

CREATE TABLE `orion_chatbox_session` (
  `username` varchar(99) NOT NULL default '',
  `lastactive` int(10) NOT NULL default '0',
  `laststatus` varchar(8) NOT NULL default '',
  UNIQUE KEY `username` (`username`)
) TYPE=MyISAM;


#
# Table structure for table `orion_confirm`
#

CREATE TABLE `orion_confirm` (
  `confirm_id` char(32) NOT NULL default '',
  `session_id` char(32) NOT NULL default '',
  `code` char(6) NOT NULL default '',
  PRIMARY KEY  (`session_id`,`confirm_id`)
) TYPE=MyISAM;

#
# Table structure for table `orion_dl_auth`
#

CREATE TABLE `orion_dl_auth` (
  `cat_id` int(11) NOT NULL default '0',
  `group_id` int(11) NOT NULL default '0',
  `auth_view` tinyint(1) NOT NULL default '1',
  `auth_dl` tinyint(1) NOT NULL default '1',
  `auth_up` tinyint(1) NOT NULL default '1',
  `auth_mod` tinyint(1) NOT NULL default '0'
) TYPE=MyISAM;


#
# Table structure for table `orion_dl_config`
#

CREATE TABLE `orion_dl_config` (
  `config_name` varchar(255) NOT NULL default '',
  `config_value` varchar(255) default NULL,
  PRIMARY KEY  (`config_name`)
) TYPE=MyISAM;


#
# Table structure for table `orion_dl_ratings`
#

CREATE TABLE `orion_dl_ratings` (
  `dl_id` int(11) default '0',
  `user_id` mediumint(8) default '0',
  `rate_point` varchar(10) default '0'
) TYPE=MyISAM;


#
# Table structure for table `orion_downloads`
#

CREATE TABLE `orion_downloads` (
  `id` int(11) NOT NULL auto_increment,
  `description` varchar(255) default NULL,
  `file_name` varchar(255) default NULL,
  `klicks` int(11) default '0',
  `free` tinyint(1) default '0',
  `extern` tinyint(1) default '0',
  `long_desc` text,
  `sort` int(11) default '0',
  `cat` int(11) default '0',
  `hacklist` tinyint(1) default '0',
  `hack_author` varchar(255) default '',
  `hack_author_email` varchar(255) default '',
  `hack_author_website` tinytext,
  `hack_version` varchar(32) default '',
  `hack_dl_url` tinytext,
  `test` varchar(50) default '',
  `req` text,
  `todo` varchar(255) default '',
  `warning` text,
  `mod_desc` text,
  `bbcode_uid` varchar(10) default '',
  `mod_list` tinyint(1) default '0',
  `file_size` int(20) unsigned default '0',
  `change_time` int(11) default '0',
  `add_time` int(11) default '0',
  `rating` smallint(5) NOT NULL default '0',
  `file_traffic` int(11) default '0',
  `overall_klicks` int(11) default '0',
  `approve` tinyint(1) default '1',
  `add_user` mediumint(8) default '0',
  `change_user` mediumint(8) default '0',
  `last_time` int(11) default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM AUTO_INCREMENT=2 ;


#
# Table structure for table `orion_downloads_cat`
#

CREATE TABLE `orion_downloads_cat` (
  `id` int(11) NOT NULL auto_increment,
  `path` varchar(255) default NULL,
  `cat_name` varchar(255) default NULL,
  `sort` int(11) default '0',
  `description` text,
  `parent` int(11) default '0',
  `bbcode_uid` varchar(10) default '',
  `auth_view` tinyint(1) NOT NULL default '1',
  `auth_dl` tinyint(1) NOT NULL default '1',
  `auth_up` tinyint(1) NOT NULL default '0',
  `auth_mod` tinyint(1) NOT NULL default '0',
  `must_approve` tinyint(1) NOT NULL default '0',
  `allow_mod_desc` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM AUTO_INCREMENT=2 ;


#
# Table structure for table `orion_extension_groups`
#

CREATE TABLE `orion_extension_groups` (
  `group_id` mediumint(8) NOT NULL auto_increment,
  `group_name` varchar(20) NOT NULL default '',
  `cat_id` tinyint(2) NOT NULL default '0',
  `allow_group` tinyint(1) NOT NULL default '0',
  `download_mode` tinyint(1) unsigned NOT NULL default '1',
  `upload_icon` varchar(100) default '',
  `max_filesize` int(20) NOT NULL default '0',
  `forum_permissions` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`group_id`)
) TYPE=MyISAM AUTO_INCREMENT=8 ;


#
# Table structure for table `orion_extensions`
#

CREATE TABLE `orion_extensions` (
  `ext_id` mediumint(8) unsigned NOT NULL auto_increment,
  `group_id` mediumint(8) unsigned NOT NULL default '0',
  `extension` varchar(100) NOT NULL default '',
  `comment` varchar(100) default NULL,
  PRIMARY KEY  (`ext_id`)
) TYPE=MyISAM AUTO_INCREMENT=29 ;


#
# Table structure for table `orion_flags`
#

CREATE TABLE `orion_flags` (
  `flag_id` int(10) NOT NULL auto_increment,
  `flag_name` varchar(25) default NULL,
  `flag_image` varchar(25) default NULL,
  PRIMARY KEY  (`flag_id`)
) TYPE=MyISAM AUTO_INCREMENT=193 ;


#
# Table structure for table `orion_forbidden_extensions`
#

CREATE TABLE `orion_forbidden_extensions` (
  `ext_id` mediumint(8) unsigned NOT NULL auto_increment,
  `extension` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`ext_id`)
) TYPE=MyISAM AUTO_INCREMENT=8 ;


#
# Table structure for table `orion_hacks_list`
#

CREATE TABLE `orion_hacks_list` (
  `hack_id` mediumint(8) unsigned NOT NULL auto_increment,
  `hack_name` varchar(255) NOT NULL default '',
  `hack_desc` varchar(255) NOT NULL default '',
  `hack_author` varchar(255) NOT NULL default '',
  `hack_author_email` varchar(255) NOT NULL default '',
  `hack_author_website` tinytext NOT NULL,
  `hack_version` varchar(32) NOT NULL default '',
  `hack_hide` enum('Yes','No') NOT NULL default 'No',
  `hack_download_url` tinytext NOT NULL,
  `hack_file` varchar(255) NOT NULL default '',
  `hack_file_mtime` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`hack_id`),
  UNIQUE KEY `hack_name` (`hack_name`),
  KEY `hack_file` (`hack_file`),
  KEY `hack_hide` (`hack_hide`)
) TYPE=MyISAM AUTO_INCREMENT=144 ;


#
# Table structure for table `orion_kb_articles`
#

CREATE TABLE `orion_kb_articles` (
  `article_id` mediumint(8) unsigned NOT NULL auto_increment,
  `article_category_id` mediumint(8) unsigned NOT NULL default '0',
  `article_title` varchar(255) binary NOT NULL default '',
  `article_description` varchar(255) binary NOT NULL default '',
  `article_date` varchar(255) binary NOT NULL default '',
  `article_author_id` mediumint(8) NOT NULL default '0',
  `username` varchar(255) default NULL,
  `bbcode_uid` varchar(10) binary NOT NULL default '',
  `article_body` text NOT NULL,
  `article_type` mediumint(8) unsigned NOT NULL default '0',
  `approved` tinyint(1) unsigned NOT NULL default '0',
  `topic_id` mediumint(8) unsigned NOT NULL default '0',
  `views` bigint(8) NOT NULL default '0',
  `article_rating` double(6,4) NOT NULL default '0.0000',
  `article_totalvotes` int(255) NOT NULL default '0',
  KEY `article_id` (`article_id`)
) TYPE=MyISAM AUTO_INCREMENT=5 ;


#
# Table structure for table `orion_kb_categories`
#

CREATE TABLE `orion_kb_categories` (
  `category_id` mediumint(8) unsigned NOT NULL auto_increment,
  `category_name` varchar(255) binary NOT NULL default '',
  `category_details` varchar(255) binary NOT NULL default '',
  `number_articles` mediumint(8) unsigned NOT NULL default '0',
  `parent` mediumint(8) unsigned default NULL,
  `cat_order` mediumint(8) unsigned NOT NULL default '0',
  `auth_view` tinyint(3) NOT NULL default '0',
  `auth_post` tinyint(3) NOT NULL default '0',
  `auth_rate` tinyint(3) NOT NULL default '0',
  `auth_comment` tinyint(3) NOT NULL default '0',
  `auth_edit` tinyint(3) NOT NULL default '0',
  `auth_delete` tinyint(3) NOT NULL default '2',
  `auth_approval` tinyint(3) NOT NULL default '0',
  `auth_approval_edit` tinyint(3) NOT NULL default '0',
  `auth_view_groups` varchar(255) default NULL,
  `auth_post_groups` varchar(255) default NULL,
  `auth_rate_groups` varchar(255) default NULL,
  `auth_comment_groups` varchar(255) default NULL,
  `auth_edit_groups` varchar(255) default NULL,
  `auth_delete_groups` varchar(255) default NULL,
  `auth_approval_groups` varchar(255) default NULL,
  `auth_approval_edit_groups` varchar(255) default NULL,
  `auth_moderator_groups` varchar(255) default NULL,
  `comments_forum_id` tinyint(3) NOT NULL default '-1',
  KEY `category_id` (`category_id`)
) TYPE=MyISAM AUTO_INCREMENT=4 ;


#
# Table structure for table `orion_kb_config`
#

CREATE TABLE `orion_kb_config` (
  `config_name` varchar(255) NOT NULL default '',
  `config_value` varchar(255) NOT NULL default ''
) TYPE=MyISAM;


#
# Table structure for table `orion_kb_custom`
#

CREATE TABLE `orion_kb_custom` (
  `custom_id` int(50) NOT NULL auto_increment,
  `custom_name` text NOT NULL,
  `custom_description` text NOT NULL,
  `data` text NOT NULL,
  `field_order` int(20) NOT NULL default '0',
  `field_type` tinyint(2) NOT NULL default '0',
  `regex` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`custom_id`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;


#
# Table structure for table `orion_kb_customdata`
#

CREATE TABLE `orion_kb_customdata` (
  `customdata_file` int(50) NOT NULL default '0',
  `customdata_custom` int(50) NOT NULL default '0',
  `data` text NOT NULL
) TYPE=MyISAM;


#
# Table structure for table `orion_kb_results`
#

CREATE TABLE `orion_kb_results` (
  `search_id` int(11) unsigned NOT NULL default '0',
  `session_id` varchar(32) NOT NULL default '',
  `search_array` text NOT NULL,
  PRIMARY KEY  (`search_id`),
  KEY `session_id` (`session_id`)
) TYPE=MyISAM;


#
# Table structure for table `orion_kb_search`
#

CREATE TABLE `orion_kb_search` (
  `search_id` int(11) unsigned NOT NULL default '0',
  `session_id` varchar(32) NOT NULL default '',
  `search_array` text NOT NULL,
  PRIMARY KEY  (`search_id`),
  KEY `session_id` (`session_id`)
) TYPE=MyISAM;


#
# Table structure for table `orion_kb_types`
#

CREATE TABLE `orion_kb_types` (
  `id` mediumint(8) unsigned NOT NULL auto_increment,
  `type` varchar(255) binary NOT NULL default '',
  KEY `id` (`id`)
) TYPE=MyISAM AUTO_INCREMENT=5 ;


#
# Table structure for table `orion_kb_votes`
#

CREATE TABLE `orion_kb_votes` (
  `votes_ip` varchar(50) NOT NULL default '0',
  `votes_userid` int(50) NOT NULL default '0',
  `votes_file` int(50) NOT NULL default '0'
) TYPE=MyISAM;


#
# Table structure for table `orion_kb_word`
#

CREATE TABLE `orion_kb_word` (
  `word_text` varchar(50) binary NOT NULL default '',
  `word_id` mediumint(8) unsigned NOT NULL auto_increment,
  `word_common` tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`word_text`),
  KEY `word_id` (`word_id`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;


#
# Table structure for table `orion_kb_wordlist`
#

CREATE TABLE `orion_kb_wordlist` (
  `word_text` varchar(50) binary NOT NULL default '',
  `word_id` mediumint(8) unsigned NOT NULL auto_increment,
  `word_common` tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`word_text`),
  KEY `word_id` (`word_id`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;


#
# Table structure for table `orion_kb_wordmatch`
#

CREATE TABLE `orion_kb_wordmatch` (
  `article_id` mediumint(8) unsigned NOT NULL default '0',
  `word_id` mediumint(8) unsigned NOT NULL default '0',
  `title_match` tinyint(1) NOT NULL default '0',
  KEY `post_id` (`article_id`),
  KEY `word_id` (`word_id`)
) TYPE=MyISAM;


#
# Table structure for table `orion_link_categories`
#

CREATE TABLE `orion_link_categories` (
  `cat_id` mediumint(8) unsigned NOT NULL auto_increment,
  `cat_title` varchar(100) NOT NULL default '',
  `cat_order` mediumint(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (`cat_id`),
  KEY `cat_order` (`cat_order`)
) TYPE=MyISAM AUTO_INCREMENT=9 ;


#
# Table structure for table `orion_link_config`
#

CREATE TABLE `orion_link_config` (
  `config_name` varchar(255) NOT NULL default '',
  `config_value` varchar(255) NOT NULL default ''
) TYPE=MyISAM;


#
# Table structure for table `orion_links`
#

CREATE TABLE `orion_links` (
  `link_id` mediumint(8) unsigned NOT NULL auto_increment,
  `link_title` varchar(100) NOT NULL default '',
  `link_desc` varchar(255) default NULL,
  `link_category` mediumint(8) unsigned NOT NULL default '0',
  `link_url` varchar(100) NOT NULL default '',
  `link_logo_src` varchar(120) default NULL,
  `link_joined` int(11) NOT NULL default '0',
  `link_active` tinyint(1) NOT NULL default '0',
  `link_hits` int(10) unsigned NOT NULL default '0',
  `user_id` mediumint(8) NOT NULL default '0',
  `user_ip` varchar(8) NOT NULL default '',
  `last_user_ip` varchar(8) NOT NULL default '',
  PRIMARY KEY  (`link_id`)
) TYPE=MyISAM AUTO_INCREMENT=2 ;


#
# Table structure for table `orion_news`
#

CREATE TABLE `orion_news` (
  `news_id` mediumint(8) unsigned NOT NULL auto_increment,
  `news_category` varchar(70) NOT NULL default '',
  `news_image` varchar(70) NOT NULL default '',
  PRIMARY KEY  (`news_id`)
) TYPE=MyISAM AUTO_INCREMENT=7 ;


#
# Table structure for table `orion_notes`
#

CREATE TABLE `orion_notes` (
  `post_id` mediumint(8) unsigned NOT NULL auto_increment,
  `poster_id` mediumint(8) NOT NULL default '0',
  `post_subject` varchar(60) default NULL,
  `post_text` text,
  `post_time` int(11) NOT NULL default '0',
  `bbcode_uid` varchar(10) default NULL,
  `bbcode` tinyint(1) NOT NULL default '1',
  `smilies` tinyint(1) NOT NULL default '1',
  `acronym` tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (`post_id`),
  KEY `poster_id` (`poster_id`),
  KEY `post_time` (`post_time`)
) TYPE=MyISAM AUTO_INCREMENT=6 ;


#
# Table structure for table `orion_orion2db`
#

CREATE TABLE `orion_orion2db` (
  `id` mediumint(8) unsigned NOT NULL auto_increment,
  `config` varchar(255) NOT NULL default '',
  `content` text NOT NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM AUTO_INCREMENT=9 ;


#
# Table structure for table `orion_portal`
#

CREATE TABLE `orion_portal` (
  `portal_name` varchar(255) NOT NULL default '',
  `portal_value` text NOT NULL,
  PRIMARY KEY  (`portal_name`)
) TYPE=MyISAM;


#
# Table structure for table `orion_q_links`
#

CREATE TABLE `orion_q_links` (
  `id` mediumint(8) unsigned NOT NULL auto_increment,
  `url` text NOT NULL,
  `name` text NOT NULL,
  `image` text NOT NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM AUTO_INCREMENT=6 ;


#
# Table structure for table `orion_quota_limits`
#

CREATE TABLE `orion_quota_limits` (
  `quota_limit_id` mediumint(8) unsigned NOT NULL auto_increment,
  `quota_desc` varchar(20) NOT NULL default '',
  `quota_limit` bigint(20) unsigned NOT NULL default '0',
  PRIMARY KEY  (`quota_limit_id`)
) TYPE=MyISAM AUTO_INCREMENT=4 ;


#
# Table structure for table `orion_stats_config`
#

CREATE TABLE `orion_stats_config` (
  `config_name` varchar(50) NOT NULL default '',
  `config_value` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`config_name`)
) TYPE=MyISAM;


#
# Table structure for table `orion_stats_modules`
#

CREATE TABLE `orion_stats_modules` (
  `module_id` tinyint(8) NOT NULL default '0',
  `name` varchar(150) NOT NULL default '',
  `active` tinyint(1) NOT NULL default '0',
  `installed` tinyint(1) NOT NULL default '0',
  `display_order` mediumint(8) unsigned NOT NULL default '0',
  `update_time` mediumint(8) unsigned NOT NULL default '0',
  `auth_value` tinyint(2) NOT NULL default '0',
  `module_info_cache` blob,
  `module_db_cache` blob,
  `module_result_cache` blob,
  `module_info_time` int(10) unsigned NOT NULL default '0',
  `module_cache_time` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`module_id`)
) TYPE=MyISAM;


#
# Table structure for table `orion_themes`
#

CREATE TABLE `orion_themes` (
  `themes_id` mediumint(8) unsigned NOT NULL auto_increment,
  `template_name` varchar(30) NOT NULL default '',
  `style_name` varchar(30) NOT NULL default '',
  `head_stylesheet` varchar(100) default NULL,
  `body_background` varchar(100) default NULL,
  `body_bgcolor` varchar(6) default NULL,
  `body_text` varchar(6) default NULL,
  `body_link` varchar(6) default NULL,
  `body_vlink` varchar(6) default NULL,
  `body_alink` varchar(6) default NULL,
  `body_hlink` varchar(6) default NULL,
  `tr_color1` varchar(6) default NULL,
  `tr_color2` varchar(6) default NULL,
  `tr_color3` varchar(6) default NULL,
  `tr_class1` varchar(25) default NULL,
  `tr_class2` varchar(25) default NULL,
  `tr_class3` varchar(25) default NULL,
  `th_color1` varchar(6) default NULL,
  `th_color2` varchar(6) default NULL,
  `th_color3` varchar(6) default NULL,
  `th_class1` varchar(25) default NULL,
  `th_class2` varchar(25) default NULL,
  `th_class3` varchar(25) default NULL,
  `td_color1` varchar(6) default NULL,
  `td_color2` varchar(6) default NULL,
  `td_color3` varchar(6) default NULL,
  `td_class1` varchar(25) default NULL,
  `td_class2` varchar(25) default NULL,
  `td_class3` varchar(25) default NULL,
  `fontface1` varchar(50) default NULL,
  `fontface2` varchar(50) default NULL,
  `fontface3` varchar(50) default NULL,
  `fontsize1` tinyint(4) default NULL,
  `fontsize2` tinyint(4) default NULL,
  `fontsize3` tinyint(4) default NULL,
  `fontcolor1` varchar(6) default NULL,
  `fontcolor2` varchar(6) default NULL,
  `fontcolor3` varchar(6) default NULL,
  `fontcolor4` varchar(6) default NULL,
  `span_class1` varchar(25) default NULL,
  `span_class2` varchar(25) default NULL,
  `span_class3` varchar(25) default NULL,
  `img_size_poll` smallint(5) unsigned default NULL,
  `img_size_privmsg` smallint(5) unsigned default NULL,
  PRIMARY KEY  (`themes_id`)
) TYPE=MyISAM AUTO_INCREMENT=5 ;


#
# Table structure for table `orion_themes_name`
#

CREATE TABLE `orion_themes_name` (
  `themes_id` smallint(5) unsigned NOT NULL default '0',
  `tr_color1_name` char(50) default NULL,
  `tr_color2_name` char(50) default NULL,
  `tr_color3_name` char(50) default NULL,
  `tr_class1_name` char(50) default NULL,
  `tr_class2_name` char(50) default NULL,
  `tr_class3_name` char(50) default NULL,
  `th_color1_name` char(50) default NULL,
  `th_color2_name` char(50) default NULL,
  `th_color3_name` char(50) default NULL,
  `th_class1_name` char(50) default NULL,
  `th_class2_name` char(50) default NULL,
  `th_class3_name` char(50) default NULL,
  `td_color1_name` char(50) default NULL,
  `td_color2_name` char(50) default NULL,
  `td_color3_name` char(50) default NULL,
  `td_class1_name` char(50) default NULL,
  `td_class2_name` char(50) default NULL,
  `td_class3_name` char(50) default NULL,
  `fontface1_name` char(50) default NULL,
  `fontface2_name` char(50) default NULL,
  `fontface3_name` char(50) default NULL,
  `fontsize1_name` char(50) default NULL,
  `fontsize2_name` char(50) default NULL,
  `fontsize3_name` char(50) default NULL,
  `fontcolor1_name` char(50) default NULL,
  `fontcolor2_name` char(50) default NULL,
  `fontcolor3_name` char(50) default NULL,
  `fontcolor4_name` char(50) default NULL,
  `span_class1_name` char(50) default NULL,
  `span_class2_name` char(50) default NULL,
  `span_class3_name` char(50) default NULL,
  PRIMARY KEY  (`themes_id`)
) TYPE=MyISAM;


#
# Table definitions added in Orion v2.3.7
#
CREATE TABLE `orion_dl_banlist`(
       `ban_id` INT(11) AUTO_INCREMENT,
       `user_id` MEDIUMINT(8) DEFAULT 0 NOT NULL,
       `user_ip` CHAR(8) DEFAULT '' NOT NULL,
       `user_agent` VARCHAR(50) DEFAULT '' NOT NULL,
       `username` VARCHAR(25) DEFAULT '' NOT NULL,
       `guests` TINYINT(1) DEFAULT 0 NOT NULL,
		PRIMARY KEY (`ban_id`));

CREATE TABLE `orion_dl_favorites` (
       `fav_id` INT(11) AUTO_INCREMENT,
       `fav_dl_id` INT(11) DEFAULT 0 NOT NULL,
       `fav_dl_cat` INT(11) DEFAULT 0 NOT NULL,
       `fav_user_id` MEDIUMINT(8) DEFAULT 0 NOT NULL,
		PRIMARY KEY (`fav_id`));
		
CREATE TABLE `orion_dl_notraf` (
       `user_id` MEDIUMINT(8) NOT NULL DEFAULT 0,
       `dl_id` INT(11) NOT NULL DEFAULT 0);
		
CREATE TABLE `orion_ctracker_config` (
			`ct_config_name` varchar(255) NOT NULL,
			`ct_config_value` varchar(255) NOT NULL,
			PRIMARY KEY  (`ct_config_name`));
			
CREATE TABLE `orion_ctracker_filechk` (
			`filepath` text,
			`hash` varchar(32) default NULL);

CREATE TABLE `orion_ctracker_filescanner` (
			`id` smallint(5) NOT NULL,
			`filepath` text,
			`safety` smallint(1) NOT NULL default '0',
			PRIMARY KEY  (`id`));

CREATE TABLE `orion_ctracker_ipblocker` (
			`id` mediumint(8) unsigned NOT NULL,
			`ct_blocker_value` varchar(250) default NULL,
			PRIMARY KEY  (`id`)) AUTO_INCREMENT=33 ;
			
CREATE TABLE `orion_ctracker_loginhistory` (
			`ct_user_id` int(10) default NULL,
			`ct_login_ip` varchar(16) default NULL,
			`ct_login_time` int(11) NOT NULL default '0');
			
CREATE TABLE `orion_wwd_counter_ips` (`ip` VARCHAR( 8 ) NOT NULL , PRIMARY KEY ( `ip` ));
CREATE TABLE `orion_dl_hotlink` (
       `user_id` MEDIUMINT(8) DEFAULT 0 NOT NULL,
       `session_id` VARCHAR(32) DEFAULT '' NOT NULL,
       `hotlink_id` VARCHAR(32) DEFAULT '' NOT NULL);