<?php
/***************************************************************************
 *                               setup.php
 *                            -------------------
 *   begin                : Sunday, Okt 16, 2005
 *   copyright            : (C) 1999-2005 by Christian Knerr, www.cback.de
 *   email                : info@cback.de
 *
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

  define('setup',true);

  // First we disable error reporting for unset Vars.
  error_reporting  (E_ERROR | E_WARNING | E_PARSE);
  set_magic_quotes_runtime(0);

  // Variable Reset
  $mode      = '';
  $language  = '';
  $step      = '';

  // And now we get mode and language
  $mode      = $_GET['mode'];
  $step      = $_GET['step'];
  $language  = $_GET['lang'];

  if(empty($lang))
  {
    $language = 'german';
  }

  // Set general Vars for later use in setup
  $orionver  = '2.4.5';
  $phpbbver  = '.0.23';
  $albumver  = '.0.54';
  $attachver = '2.4.5';
  $calver    = '1.4.7';
  $ctversion = '5.0.5';
  $dlversion = '5.3.0';

  // Sprachdatei einbinden
  if(file_exists("language/" . $language . ".php"))
  {
    include("language/$language.php");
  }
  else
  {
    die("<h2>CBACK Orion Setup</h2><br>The selected language doesn't exist. Please check if you have uploaded the folder <b>setup/language/</b> completely!<br><br>Die gewhlte Sprache existiert nicht. Bitte stelle sicher, dass Du den Ordner <b>setup/language/</b> vollstndig hochgeladen hast!");
  }

  // Letzter Schritt
  if($step == 4 && $mode == 'dlconfig')
  {
    header('Content-Type: text/x-delimtext; name="config.php"');
    header('Content-disposition: attachment; filename="config.php"');
    $configdownload = $HTTP_POST_VARS['conf_data'];
    if(empty($configdownload))
    {
      // PHP >5.0.5
      $configdownload = $_POST['conf_data'];
    }
    echo stripslashes($configdownload);
	exit;
  }

  // Global Header for Setup
  include("includes/header.php");

  // Setupschritte
  if($step == 1)
  {
    include("includes/step1.php");
  }
  else if($step == 2)
  {
    include("includes/step2.php");
  }
  else if($step == 3)
  {
    if($mode == 'update')
    {
      include("includes/sql_parse.php");
	  include("includes/update.php");
    }
    else if ($mode == 'install')
    {
      include("includes/sql_parse.php");
	  include("includes/install.php");
    }
    else
    {
      die("<h3>CBACK Orion Setup</h3><br>Invalid Setup Mode<br><br>Ungltige Setupmethode!");
    }
  }
  else if($step == 4)
  {
    include("includes/step4.php");
  }
  else
  {
    include("includes/welcome.php");
  }

  // Global Footer for Setup
  include("includes/footer.php");

?>